//---------------------------------------------------------------------
// 	Copyright  1991 Apple Computer, Japan Inc. All rights reserved.
//
//		'91 Dec.11  Programed by Taro Tanaka
//
//		Developer Technical Supprt, Service and Support
//		
//---------------------------------------------------------------------

#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Printing.rsrc";

include $$Shell("ObjApp")"Draw" 'CODE';

include $$Shell("SrcApp")"Icon.rsrc";		//   ICON 1000   
include $$Shell("SrcApp")"Views.rsrc";		//   view 1000

include "Defaults.rsrc"	'ALRT' (phAboutApp);			// default about window
include "Defaults.rsrc"	'DITL' (phAboutApp);			// default about contents
include "Defaults.rsrc"	'STR#' (kDefaultCredits);	// default credits
include "Defaults.rsrc" 'vers' (1);						// Application or file specific
include "Defaults.rsrc" 'vers' (2);						// Overall package
include "Defaults.rsrc"  'MApp' (0);

// =================================================================
#define  cSketcher      	1000

#define  cBlack 				2001
#define  cRed 					2002
#define  cGreen 				2003
#define  cBlue					2004

#define  cDeleteFirst		3001
#define  cDeleteFirstMsg	3101

#define	cSetSelf				4001
#define	cSetTargetAddress	4002
#define	cLaunch				4003

#define	cSound				4501

#define	cAEOpen				5001
#define	cAEPrint				5002
#define	cAENew				5003
#define	cAEClose				5004
#define	cAEAboutApp			5005

// =================================================================
resource 'seg!' (256,
#if qNames
"Draw",
#endif
	purgeable) {
	{	"GPrint";
		"GSelCommand";
	}
};

// =================================================================
resource 'cmnu' (mApple,
#if qNames
"mApple",
#endif
nonpurgeable) {
	mApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{
	"About", noIcon, noKey, noMark, plain, cAEAboutApp;		// The ^0 will be dynamically replaced with CurApName
																					// * AppleEvent
	"-",		 noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (mFile,
#if qNames
"mFile",
#endif
nonpurgeable) {
	mFile,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"File",
	{
	"New",					noIcon, "N",	noMark, plain, cAENew;		// * AppleEvent
	"Open",					noIcon, "O",	noMark, plain, cAEOpen;		// * AppleEvent
	"-",						noIcon, noKey,	noMark, plain, nocommand;
	"Close",					noIcon, "W",	noMark, plain, cAEClose;	// * AppleEvent
	"Save",					noIcon, "S",	noMark, plain, cSave;
	"Save As",				noIcon, noKey,	noMark, plain, cSaveAs;
	"Save a Copy In",	noIcon, noKey,	noMark, plain, cSaveCopy;
	"Revert",				noIcon, noKey,	noMark, plain, cRevert;
	"-",						noIcon, noKey,	noMark, plain, nocommand;
	"Page Setup",			noIcon, noKey,	noMark, plain, cPageSetup;
	"Print One",			noIcon, noKey,	noMark, plain, cPrintOne;
	"Print",				noIcon, "P",	noMark, plain, cPrint;		// * AppleEvent
	"-",						noIcon, noKey,	noMark, plain, nocommand;
	"Quit",					noIcon, "Q",	noMark, plain, cQuit			// * AppleEvent
	}
};

include "Defaults.rsrc"	'cmnu' (mEdit);				// default Edit menu

resource 'cmnu' (4) {
	4,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Color",
	 {
		"Black", noIcon, "K", noMark, plain, cBlack;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Red", noIcon, "R", noMark, plain, cRed;
		"Green", noIcon, "G", noMark, plain, cGreen;
		"Blue", noIcon, "B", noMark, plain, cBlue;
	}
};

resource 'cmnu' (5) {
	5,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Delete",
	 {
		"First", noIcon, "F", noMark, plain, cDeleteFirst;
	}
};

resource 'cmnu' (6) {
	6,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Target",
	 {
		"Self", noIcon, noKey, noMark, plain, cSetSelf;
		"other", noIcon, noKey, noMark, plain, cSetTargetAddress;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Launch", noIcon, noKey, noMark, plain, cLaunch;
	}
};

resource 'cmnu' (7) {
	7,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Sound",
	 {
		"Sound", noIcon, noKey, noMark, plain, cSound;
	}
};

resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	 {
		"Page Setup Change", noIcon, noKey, noMark, plain, cChangePrinterStyle;
		"Sketch", noIcon, noKey, noMark, plain, cSketcher;
		"Delete First", noIcon, noKey, noMark, plain, cDeleteFirstMsg;
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"Calc",
#endif
	purgeable) {
	{mApple; mFile; mEdit; 4; 5; 6; 7; }
};


//  ------------------------------------------------------------------------------ 
resource 'mctb' (4) {
	{
	//  Black 
	4, 1,
		{
		0x0000, 0x0000, 0x0000;			//  Mark color 
		0x0000, 0x0000, 0x0000;			//  Name color 
		0x0000, 0x0000, 0x0000;			//  Command Key color 
		0xFFFF, 0xFFFF, 0xFFFF			//  Background color 
		};
	//  Red 
	4, 3,
		{
		0xDB00, 0x0000, 0x0000;			//  Mark color 
		0xDB00, 0x0000, 0x0000;			//  Name color 
		0xDB00, 0x0000, 0x0000;			//  Command Key color 
		0xFFFF, 0xFFFF, 0xFFFF			//  Background color 
		};
	//  Green 
	4, 4,
		{
		0x0000, 0xDB00, 0x0000;			//  Mark color 
		0x0000, 0xDB00, 0x0000;			//  Name color 
		0x0000, 0xDB00, 0x0000;			//  Command Key color 
		0xFFFF, 0xFFFF, 0xFFFF			//  Background color 
		};
	//  Blue 
	4, 5,
		{
		0x0000, 0x0000, 0xFFFF;			//  Mark color 
		0x0000, 0x0000, 0xFFFF;			//  Name color 
		0x0000, 0x0000, 0xFFFF;			//  Command Key color 
		0xFFFF, 0xFFFF, 0xFFFF			//  Background color 
		};
	}
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	acceptChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,		// highlevel event aware
	localAndRemoteHLEvents,		//	local and remote highlevel event aware
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qdebug
	450 * 1024,
	368 * 1024
#else
	300 * 1024,
	200 * 1024
#endif
};
